"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _fill = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/fill"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _react = _interopRequireDefault(require("react"));

var _reactKonva = require("react-konva");

var HighlightShape = function HighlightShape(_ref) {
  var width = _ref.width,
      height = _ref.height,
      masks = _ref.masks,
      currentMask = _ref.currentMask;
  return _react["default"].createElement(_reactKonva.Shape, {
    x: 0,
    y: 0,
    width: width,
    height: height,
    sceneFunc: function sceneFunc(ctx, shape) {
      ctx.beginPath();
      ctx.moveTo(0, 0);
      ctx.lineTo(width, 0);
      ctx.lineTo(width, height);
      ctx.lineTo(0, height);
      ctx.lineTo(0, 0);
      ctx.closePath();
      (0, _forEach["default"])(masks).call(masks, function (maskPoints) {
        var startPoint = maskPoints[0];
        ctx.moveTo(startPoint[0], startPoint[1]);
        (0, _forEach["default"])(maskPoints).call(maskPoints, function (point) {
          ctx.lineTo(point[0], point[1]);
        });
        ctx.closePath();
      });

      if (currentMask.startX != -1 && currentMask.endX !== -1) {
        ctx.moveTo(currentMask.startX, currentMask.startY);
        ctx.lineTo(currentMask.startX, currentMask.endY);
        ctx.lineTo(currentMask.endX, currentMask.endY);
        ctx.lineTo(currentMask.endX, currentMask.startY);
        ctx.lineTo(currentMask.startX, currentMask.startY);
        ctx.closePath();
      }

      ctx.fillStyle = 'rgba(0,0,0,0.3)';
      ctx.strokeStyle = 'rgba(0.5,0.5,0.5,0.5)';
      ctx.lineWidth = 1;
      (0, _fill["default"])(ctx).call(ctx);
      ctx.stroke();
    }
  });
};

var _default = HighlightShape;
exports["default"] = _default;