"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = void 0;

var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _reactKonva = require("react-konva");

var _canvas = require("../../utils/canvas");

var _highlightShape = _interopRequireDefault(require("./highlight-shape"));

var FeedbackDrawer =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2["default"])(FeedbackDrawer, _React$Component);

  function FeedbackDrawer(props) {
    var _context, _context2, _context3;

    var _this;

    (0, _classCallCheck2["default"])(this, FeedbackDrawer);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FeedbackDrawer).call(this, props));
    _this.state = {
      isDrawing: false,
      highlightMasks: [// [[100, 100], [100, 400], [200, 400], [200, 100], [100, 100]]
      ],
      currentStartX: -1,
      currentStartY: -1,
      currentEndX: -1,
      currentEndY: -1
    };
    _this.onMouseDown = (0, _bind["default"])(_context = _this.onMouseDown).call(_context, (0, _assertThisInitialized2["default"])(_this));
    _this.onMouseUp = (0, _bind["default"])(_context2 = _this.onMouseUp).call(_context2, (0, _assertThisInitialized2["default"])(_this));
    _this.onMouseMove = (0, _bind["default"])(_context3 = _this.onMouseMove).call(_context3, (0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(FeedbackDrawer, [{
    key: "onMouseDown",
    value: function onMouseDown(event) {
      if (this.props.isCanvasActive && !this.state.isDrawing) {
        this.setState({
          isDrawing: true,
          currentStartX: event.evt.offsetX,
          currentStartY: event.evt.offsetY
        });
      }
    }
  }, {
    key: "onMouseUp",
    value: function onMouseUp(event) {
      if (this.props.isCanvasActive && this.state.isDrawing) {
        this.setState(function (prevState) {
          var highlightMasks = prevState.highlightMasks,
              currentStartX = prevState.currentStartX,
              currentStartY = prevState.currentStartY;
          var startX = currentStartX >= event.evt.offsetX ? currentStartX : event.evt.offsetX;
          var startY = currentStartY >= event.evt.offsetY ? currentStartY : event.evt.offsetY;
          var endX = currentStartX < event.evt.offsetX ? currentStartX : event.evt.offsetX;
          var endY = currentStartY < event.evt.offsetY ? currentStartY : event.evt.offsetY;
          var newHighlightMask = [[startX, startY], [startX, endY], [endX, endY], [endX, startY], [startX, startY]];
          var newHighlightMasks = (0, _canvas.includeNewMask)({
            highlightMasks: highlightMasks,
            newHighlightMask: newHighlightMask
          });
          return {
            isDrawing: false,
            currentStartX: -1,
            currentStartY: -1,
            currentEndX: -1,
            currentEndY: -1,
            highlightMasks: newHighlightMasks
          };
        });
      }
    }
  }, {
    key: "onMouseMove",
    value: function onMouseMove(event) {
      if (this.props.isCanvasActive && this.state.isDrawing) {
        this.setState({
          currentEndX: event.evt.offsetX,
          currentEndY: event.evt.offsetY
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var width = document.body.scrollWidth;
      var height = document.body.scrollHeight;
      var _this$state = this.state,
          highlightMasks = _this$state.highlightMasks,
          currentStartX = _this$state.currentStartX,
          currentStartY = _this$state.currentStartY,
          currentEndX = _this$state.currentEndX,
          currentEndY = _this$state.currentEndY;
      return _react["default"].createElement(_reactKonva.Stage, {
        style: {
          position: 'fixed',
          top: 0,
          left: 0,
          zIndex: 1
        },
        width: width,
        height: height
      }, _react["default"].createElement(_reactKonva.Layer, null, _react["default"].createElement(_reactKonva.Group, null, _react["default"].createElement(_highlightShape["default"], {
        masks: highlightMasks,
        currentMask: {
          startX: currentStartX,
          startY: currentStartY,
          endX: currentEndX,
          endY: currentEndY
        },
        width: width,
        height: height
      }), _react["default"].createElement(_reactKonva.Rect, {
        id: "fake-background",
        x: 0,
        y: 0,
        width: width,
        height: height,
        onMouseDown: this.onMouseDown,
        onMouseUp: this.onMouseUp,
        onMouseMove: this.onMouseMove
      }))));
    }
  }]);
  return FeedbackDrawer;
}(_react["default"].Component);

var _default = FeedbackDrawer;
exports["default"] = _default;