"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.includeNewMask = exports.calcMasksIntersect = void 0;

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _reverse = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reverse"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _polygonClipping = _interopRequireDefault(require("polygon-clipping"));

var calcMasksIntersect = function calcMasksIntersect(_ref) {
  var mask1 = _ref.mask1,
      mask2 = _ref.mask2;
  return _polygonClipping["default"].intersection([mask1], [mask2]).length > 0;
};

exports.calcMasksIntersect = calcMasksIntersect;

var includeNewMask = function includeNewMask(_ref2) {
  var highlightMasks = _ref2.highlightMasks,
      newHighlightMask = _ref2.newHighlightMask;
  var isIntersection = false;
  var newHighlightMasks = (0, _toConsumableArray2["default"])(highlightMasks); // Detect & union intersecting polygons

  for (var i = 0; i < highlightMasks.length; i++) {
    var tmpMask = highlightMasks[i];
    isIntersection = calcMasksIntersect({
      mask1: tmpMask,
      mask2: newHighlightMask
    });

    if (isIntersection) {
      var _context;

      var points = _polygonClipping["default"].union([tmpMask], [newHighlightMask])[0]; // sort counter clow wise


      var ccwMask = (0, _reverse["default"])(_context = points[0]).call(_context);
      newHighlightMasks[i] = ccwMask;
      break;
    }
  }

  if (!isIntersection) {
    var _context2;

    newHighlightMasks = (0, _concat["default"])(_context2 = []).call(_context2, (0, _toConsumableArray2["default"])(newHighlightMasks), [newHighlightMask]);
  }

  return newHighlightMasks;
};

exports.includeNewMask = includeNewMask;